| C prototype: void FastOutlinedRect(unsigned char* plane,short x1,short y1,short x2,short y2,short mode) __attribute__((__stkparm__));
| Valid values for mode are: A_REVERSE, A_XOR, A_NORMAL, A_REPLACE. In fact, 
| A_NORMAL (same effect as A_REPLACE) is assumed if the mode is neither
| A_REVERSE nor A_XOR.
|
| This piece of code uses the nasty trick of code patching so as to be much
| smaller and also faster if the mode is not changed too often.
| What's more, given that the following opcodes:
| or.w %d0,(%a0)+    0x8118
| eor.w %d0,(%a0)+   0xB118
| and.w %d0,(%a0)+   0xC118
|
| or.w %d2,(%a0)+    0x8558
| eor.w %d2,(%a0)+   0xB558
| and.w %d2,(%a0)+   0xC558
|
| bset %d2,(%a0) ... 0x03d0 (0x400 - 0x30)
| bclr %d2,(%a0) ... 0x0390 (0x400 - 0x70)
| bchg %d2,(%a0) ... 0x0350 (0x300 + 0x50)
|
| bset %d3,(%a1) ... 0x07d1 (0x800 - 0x30)
| bclr %d3,(%a1) ... 0x0791 (0x800 - 0x70)
| bchg %d3,(%a1) ... 0x0751 (0x700 + 0x50)

| are mainly similar, we can optimize...
|
| However, there is nothing to optimize on the following opcodes:
| move.w %d5,(%a0)+  0x30C5
| not.w (%a0)+       0x4658
| move.w %d5,(%a1)+  0x32C5
| not.w (%a1)+       0x4659

| pb si hauteur ou largeur nulle...

| CURRENTLY DOESN'T WORK !
| TODO: * reimplement everything, to draw 16 pixels each time.
|       * update the comments.
|       * make the __regparm__ version.

.data
.even
/*
__First_FOR__:
.byte 0xFF,0x7F,0x3F,0x1F,0x0F,0x07,0x03,0x01

__Last_FOR__:
.byte 0x80,0xC0,0xE0,0xF0,0xF8,0xFC,0xFE,0xFF

.globl FastOutlinedRect
.even
FastOutlinedRect:
    movem.l  %d3-%d7/%a2-%a3,-(%sp)
    
    move.w   4+28+4(%sp),%d0                 | x1.
    move.w   4+28+6(%sp),%d1                 | y1.
    move.w   4+28+8(%sp),%d2                 | x2.
    move.w   4+28+10(%sp),%d3                | y2.
    
    cmp.w    %d1,%d3
    bge.s    __continue_FOR__

    exg      %d1,%d3

__continue_FOR__:
    sub.w    %d1,%d3                         | dy -> d3.
    move.w   %d3,%d6                         | d3 -> d6.

    cmp.w    %d0,%d2
    bge.s    __patch_the_code_FOR__
    exg      %d0,%d2


__patch_the_code_FOR__:
    | If mode is not A_REVERSE or A_XOR, A_NORMAL is assumed. That allows
    | the use of A_REPLACE and A_OR modes.
    move.w   4+28+12(%sp),%d5

    cmp.w    __previous_mode_FOR__(%pc),%d5
    beq.s    __no_patch_FOR__
    lea      __First_part_FOR__(%pc),%a2

    move.w   %d5,__previous_mode_FOR__-__First_part_FOR__(%a2)
    beq.s    __patch_clr_FOR__
    cmpi.w   #2,%d5
    beq.s    __patch_eor_FOR__
    moveq    #-0x7F,%d7                      | -0x7F = 0x81.
    moveq    #-0x30,%d4                      | -0x30 = 0xD0.
    bra.s    __patch_clr_and_or_FOR__
__patch_clr_FOR__:
    moveq    #-0x3F,%d7                      | -0x3F = 0xC1.
    moveq    #-0x70,%d4                      | -0x70 = 0x90.
__patch_clr_and_or_FOR__:
|    move.w   #0x10C5,__Middle_16_FOR__-__First_part_FOR__(%a2)
|    move.w   #0x12C5,__Middle_16_FOR__-__First_part_FOR__+2(%a2)
    bra.s    __end_patch_FOR__

__patch_eor_FOR__:
    moveq    #-0x4F,%d7                      | -0x4F = 0xB1.
    moveq    #+0x50,%d4
|    move.w   #0x4618,__Middle_16_FOR__-__First_part_FOR__(%a2)
|    move.w   #0x4619,__Middle_16_FOR__-__First_part_FOR__+2(%a2)

__end_patch_FOR__:
    move.b   %d7,(%a2)
    move.b   %d7,2(%a2)
    addq.b   #4,%d7
    move.b   %d7,__Last_part_FOR__-__First_part_FOR__(%a2)
    move.b   %d7,__Last_part_FOR__-__First_part_FOR__+2(%a2)
    
    move.b   %d4,__First_part2_FOR__-__First_part_FOR__+1(%a2)
    addq.b   #1,%d4
    move.b   %d4,__First_part2_FOR__-__First_part_FOR__+3(%a2)

|    move.w    __previous_mode_FOR__(%pc),%d5

__no_patch_FOR__:
    movea.l  4+28+0(%sp),%a0                 | plane.

    add.w    %d1,%d1
    move.w   %d1,%d4
    lsl.w    #4,%d1
    sub.w    %d4,%d1
    adda.w   %d1,%a0

    move.l   %a0,%a2
    
    move.w   %d0,%d4
    lsr.w    #3,%d4
    adda.w   %d4,%a0
| a0=address of the top left corner of the rectangle (not necessarily even).

    move.w   %d4,%d7                         | save d4.

    move.w   %d3,%d1
    lsl.w    #4,%d1
    sub.w    %d3,%d1
    add.w    %d1,%d1
    lea      0(%a0,%d1.w),%a1
| a1=address of the bottom left corner of the rectangle (not necessarily even).

    move.w   %d2,%d4
    lsr.w    #3,%d4
    adda.w   %d4,%a3
| a3=address of the top right corner of the rectangle.

    andi.w   #0x7,%d0
| d1 and d3 will be used by bchg/bclr/bset.
    moveq    #0x7,%d1
    moveq    #0x7,%d3
    sub.w    %d0,%d1
    move.w   %d2,%d4
    andi.w   #0x7,%d2
    sub.w    %d2,%d3

    lea      __First_FOR__(%pc),%a2
    move.b   0(%a2,%d0.w),%d0    | d0 = mask of first pixels.

    move.b   __Last_FOR__-__First_FOR__(%a2,%d2.w),%d2 | d1 = mask of last pixels.

| d7 = 8 * (x1/16 + x1/16) + 16. We add 1 before shifting instead of adding 16 
| after shifting (gain: 4 clocks and 2 bytes).
    addq.w   #1,%d7
    lsl.w    #3,%d7
    
    tst.w    %d5
    bne.s    __not_A_REVERSE_FOR__
| Don't forget to invert the masks for A_REVERSE mode !
    not.w    %d0
    not.w    %d2
    moveq    #0,%d5
    bra.s    __finish_setup_FOR__
__not_A_REVERSE_FOR__:
    moveq    #-1,%d5
__finish_setup_FOR__:

    movea.l  %a0,%a2
    
    
    cmp.w    %d7,%d4                         | Line less than 16 pixels long ?
    bge.s    __More_than_16_pixels_FOR__
| Instead of coding a complete and quite long block testing for mode and
| writing to the plane accordingly, we can simply branch to __End_FOR__ after
| doing the necessary operations. This is both faster and smaller...
    and.w    %d0,%d2
    bra.s    __Last_part_of_horizontal_line_FOR__

__More_than_16_pixels_FOR__:
    sub.w    %d7,%d4                         | d4 = x2 - x.
    move.w   %d4,%d7
__First_part_of_horizontal_line_FOR__:
    .word    0x0018
    subq.w   #8,%d4
    ble.s    __Last_part_of_horizontal_line_FOR__
__Middle_of_horizontal_line_FOR__:
    .word    0
    subq.w   #8,%d4
    bgt.s    __Middle_of_horizontal_line_FOR__
__Last_part_of_horizontal_line_FOR__:
    .word    0x0010
    
    tst.w    %d6
    beq.s    __dy_is_0_FOR__
    move.w   %d7,%d4
    move.w   %d6,%d7
    moveq    #1,%d6
    move.l   %a1,%a0
    bra.s    __First_part_of_horizontal_line_FOR__

__dy_is_0_FOR__:

__Bottom_line_beginning_FOR__:
    .word    0x0019
    subq.w   #8,%d4
    ble.s    __Bottom_line_beginning_FOR__
__Bottom_line_middle_16_FOR__:
    .word    0
    subq.w   #8,%d4
    bgt.s    __Bottom_line_middle_16_FOR__
__Bottom_line_end_FOR__:
    .word    0x0011

__Last_part_FOR__:
    move.l   %a2,%a1
    move.l   %a3,%a0
__First_part2_FOR__:
    .word    0x0300
    .word    0x0700
    lea      30(%a0),%a0
    lea      30(%a1),%a1
    dbf      %d6,__First_part2_FOR__
*/

/*
__More_than_16_pixels_FOR__:
    sub.w    %d4,%d2                         | d2 = x2 - x.
    tst.w    %d5
    bne.s    __not_A_REVERSE_FOR__
| Don't forget to invert the masks for A_REVERSE mode !
    not.w    %d0
    not.w    %d1
    moveq    #0,%d5
    bra.s    _First_part_FOR__
__not_A_REVERSE_FOR__:
    moveq    #-1,%d5
_First_part_FOR__:
    move.w   %d3,%d4
    movea.l  %a0,%a1
__First_part_FOR__:
    .word    0x0050
    lea      30(%a0),%a0
    dbf      %d3,__First_part_FOR__

    addq.l   #2,%a1
    movea.l  %a1,%a0
    move.w   %d4,%d3
    subi.w   #32,%d2
    blt.s    __Middle_16_FOR__
__Middle_32_FOR__:
    .word    0
    lea      30(%a0),%a0
    dbf      %d3,__Middle_32_FOR__
    addq.l   #4,%a1
    movea.l  %a1,%a0
    move.w   %d4,%d3
    subi.w   #32,%d2
    bge.s    __Middle_32_FOR__
__Middle_16_FOR__:
    cmpi.w   #-16,%d2
    blt.s    __End_FOR__
_Middle_16_FOR__:
    .word    0
    lea      30(%a0),%a0
    dbf      %d3,_Middle_16_FOR__
    lea      2(%a1),%a0
__End_FOR__:
    .word    0x0050
    lea      30(%a0),%a0
    dbf      %d4,__End_FOR__
*/
/*    movem.l  (%sp)+,%d3-%d7/%a2-%a3
    rts

__previous_mode_FOR__:
.word 0xFFFF
*/