| C prototype: void GraySprite16_SHADOW_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned short *mask,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
|
| Original routine by geogeo (Geoffrey Anneheim), modified to reduce size
| and take non-interlaced sprites by Lionel Debroux.

.data
.globl GraySprite16_SHADOW_R
.even

GraySprite16_SHADOW_R:
    dbf      %d2,__rest_of_GraySprite16_SHADOW_R__
    rts

__rest_of_GraySprite16_SHADOW_R__:
    move.l   %d3,-(%sp)
    move.l   %d4,-(%sp)
    move.l   %a2,-(%sp)
    
    move.l   4+12(%sp),%a2

    move.w   %d1,%d3	| d3 = y
    lsl.w    #4,%d1	| d1 = 16*y
    sub.w    %d3,%d1	| d1 = 15*y

    move.w   %d0,%d3	| d3 = x
    lsr.w    #4,%d3	| d3 = x/16

    add.w    %d3,%d1	| d1 = 15*y + x/16
    add.w    %d1,%d1	| d1 = 30*y + x/8
    adda.w   %d1,%a0	| a0 += offset
    adda.w   %d1,%a1	| a1 += offset

    andi.w   #0xF,%d0
    cmpi.w   #8,%d0
    bgt.s    _loop_GraySprite16_SHADOW_R_2
|    move.w   %d0,%d1

_loop_GraySprite16_SHADOW_R_1:
    move.l   (%a0),%d1
|    move.l   (%a0),%d0
    move.l   (%a1),%d4

    move.l   %d1,%d3
|    move.l   %d0,%d3
    not.l    %d3
    or.l     %d4,%d3
    or.l     %d1,%d4
|    or.l     %d0,%d4
    
    moveq.l  #-1,%d1
|    moveq.l  #-1,%d0
    move.w   (%a2)+,%d1
|    move.w   (%a2)+,%d0
    swap     %d1
|    swap     %d0
    ror.l    %d0,%d1
|    ror.l    %d1,%d0
    and.l    %d1,(%a0)
|    and.l    %d0,(%a0)
    and.l    %d1,(%a1)
|    and.l    %d0,(%a1)
    not.l    %d1
|    not.l    %d0
    and.l    %d1,%d3
|    and.l    %d0,%d3
    and.l    %d1,%d4
|    and.l    %d0,%d4
    
    or.l     %d3,(%a0)
    or.l     %d4,(%a1)
    
    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,_loop_GraySprite16_SHADOW_R_1
    movea.l  (%sp)+,%a2
    move.l   (%sp)+,%d4
    move.l   (%sp)+,%d3
    rts

_loop_GraySprite16_SHADOW_R_2:
    moveq    #16,%d1
    sub.w    %d0,%d1

__loop_GraySprite16_SHADOW_R_2:
    move.l   (%a0),%d0
    move.l   (%a1),%d4
    
    move.l   %d0,%d3
    not.l    %d3
    or.l     %d4,%d3
    or.l     %d0,%d4

    moveq.l  #-1,%d0
    move.w   (%a2)+,%d0
    rol.l    %d1,%d0
    and.l    %d0,(%a0)
    and.l    %d0,(%a1)
    not.l    %d0
    and.l    %d0,%d3
    and.l    %d0,%d4
    
    or.l     %d3,(%a0)
    or.l     %d4,(%a1)

    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,__loop_GraySprite16_SHADOW_R_2
    movea.l  (%sp)+,%a2
    move.l   (%sp)+,%d4
    move.l   (%sp)+,%d3
    rts


/*
	xdef	DrawSprite16_SHADOW

DrawSprite16_SHADOW:
    dbf      %d2,__suite__
    rts

__suite__:
    move.l   %d3,-(%sp)
    move.l   %d4,-(%sp)

    move.w   %d1,%d3
    lsl.w    #4,%d1
    sub.w    %d3,%d1

    move.w   %d0,%d3
    lsr.w    #4,%d3

    add.w    %d3,%d1
    add.w    %d1,%d1
    adda.w   %d1,%a0

    andi.w   #0xF,%d0
    cmpi.w   #7,%d0
    bls.s    Pre_Boucle16_LSR

    moveq    #16,%d1
    sub.w    %d0,%d1

    lsr.w    #1,%d2
    bcs.s    _loop_Sprite16_MASK

    lea.l    -30(%a0),%a0
    bra.s    Milieu_Boucle16

_loop_Sprite16_MASK:
    move.l   (%a0),%d0
    move.l   6000(%a0),%d4
    
    |lightplane
    move.l   %d0,%d3
    not.l    %d3
    or.l     %d4,%d3
    
    |darkplane
    or.l     %d0,%d4
    
    | masque
    moveq.l  #-1,%d0
    move.w   (%a1)+,%d0
    rol.l    %d1,%d0
    and.l    %d0,(%a0)
    and.l    %d0,6000(%a0)
    not.l    %d0
    and.l    %d0,%d3
    and.l    %d0,%d4
    
    | Zone d'ombres
    or.l     %d3,(%a0)
    or.l     %d4,6000(%a0)
    
    addq.l   #4,%a1

Milieu_Boucle16:
    move.l   30(%a0),%d0
    move.l   6000+30(%a0),%d4
    
    |lightplane
    move.l   %d0,%d3
    not.l    %d3
    or.l     %d4,%d3
    
    |darkplane
    or.l     %d0,%d4
    
    | masque
    moveq.l  #-1,%d0
    move.w   (%a1)+,%d0
    rol.l    %d1,%d0
    and.l    %d0,30(%a0)
    and.l    %d0,6000+30(%a0)
    not.l    %d0
    and.l    %d0,%d3
    and.l    %d0,%d4
    
    | Zone d'ombres
    or.l     d3,30(a0)
    or.l     d4,6000+30(a0)
    
    addq.l   #4,a1
    
    lea.l    60(a0),a0

    dbf      d2,_loop_Sprite16_MASK
    move.l   (a7)+,d4
    move.l   (a7)+,d3
    rts

Pre_Boucle16_LSR:
    lsr.w    #1,d2
    bcs.s    Boucle16_LSR

    lea.l    -30(a0),a0
    bra.s    Milieu_Boucle16_LSR

Boucle16_LSR:
    move.l   (a0),d1
    move.l   6000(a0),d4
    
    |lightplane
    move.l   d1,d3
    not.l    d3
    or.l     d4,d3
    
    |darkplane
    or.l     d1,d4
    
    | masque
    moveq.l  #-1,d1
    move.w   (a1)+,d1
    swap     d1
    ror.l    d0,d1
    and.l    d1,(a0)
    and.l    d1,6000(a0)
    not.l    d1
    and.l    d1,d3
    and.l    d1,d4
    
    | Zone d'ombres
    or.l     d3,(a0)
    or.l     d4,6000(a0)
    
    addq.l   #4,a1

Milieu_Boucle16_LSR:
    move.l   30(a0),d1
    move.l   6000+30(a0),d4
    
    |lightplane
    move.l   d1,d3
    not.l    d3
    or.l     d4,d3
    
    |darkplane
    or.l     d1,d4
    
    | masque
    moveq.l  #-1,d1
    move.w   (a1)+,d1
    swap     d1
    ror.l    d0,d1
    and.l    d1,30(a0)
    and.l    d1,6000+30(a0)
    not.l    d1
    and.l    d1,d3
    and.l    d1,d4
    
    | Zone d'ombres
    or.l     d3,30(a0)
    or.l     d4,6000+30(a0)
    
    addq.l   #4,a1

    lea.l    60(a0),a0

    dbf      d2,Boucle16_LSR
    move.l   (a7)+,d4
    move.l   (a7)+,d3
    rts
*/
