| C prototype: void GraySprite32_SHADOW_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned long *mask,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
|
| Original routine by geogeo (Geoffrey Anneheim). It is actually the code in
| Arkanoid Revenge of DOH, unmodified (A68k assembly, it uses a non-standard
| plane format, it takes interlaced sprites, etc.)
| This sprite size is less frequent than 8 and 16, and this code is
| suboptimal. I'll optimize it by using stack less often (before trying to
| implement my ideas, I don't think that doing without using the stack is
| possible):
|   * put the loop counter on the stack (used only once per iteration);
|   * put both shift counts in the same register (pairs of swap needed).
| and I'll contribute it back to geogeo.

| Original routine by geogeo (Geoffrey Anneheim), modified to reduce size
| and take non-interlaced sprites by Lionel Debroux.

/*
GraySprite32_SHADOW_R:
    dbf      %d2,__rest_of_GraySprite32_SHADOW_R__
    rts

__rest_of_GraySprite32_SHADOW_R__:
| Put loop counter on the stack so as to have more registers.
| The loop counter is used only once per iteration.
    move.w   %d2,-(%sp)
    movem.l  %d3-%d7/%a2,-(%sp)
    
    |y*15 
    move.w   %d1,%d2
    lsl.w    #4,%d1
    sub.w    %d2,%d1
    
    |x/16
    move.w   %d0,%d2
    lsr.w    #4,%d2
    
    add.w    %d2,%d1
    add.w    %d1,%d1
| geogeo, attention au gros bug adda.l %d1,%a0 ici !
    adda.w   %d1,%a0
    adda.w   %d1,%a1
    	
    andi.w   #15,%d0          | d0=rightshift
    moveq.l  #8,%d1
    sub.w    %d0,%d1          | d1=lefshift

| Compute left mask and right mask at the same time.
    moveq    #-1,%d4
    lsr.w    %d0,%d4
    move.w   %d4,%d5
    not.w    %d4
    swap     %d4

| Put the two shift counts in the same register so as to have more 
| registers...
    swap     %d0
    move.w   %d1,%d0

| Two shiftings instead of a loop unrolled twice, this is more 
| interesting speed-wise...
    tst.w    %d0
    bgt.s    __loop_GraySprite3_SHADOW_R_2
    
    neg.w    %d0

"
    andi.w   #0xF,%d0
    moveq    #8,%d1
    sub.w    %d0,%d1
    bgt.s    __loop_GraySprite8_SHADOW_R_2

    neg.w    %d1
_loop_GraySprite8_SHADOW_R_1:
    move.l   (%a0),%d0
    move.l   (%a1),%d4

    move.l   %d0,%d3
    not.l    %d3
    or.l     %d4,%d3
    or.l     %d0,%d4
    
    moveq.l  #-1,%d0
    move.b   (%a2)+,%d0
    rol.l    %d1,%d0
    and.l    %d0,(%a0)
    and.l    %d0,(%a1)
    not.l    %d0
    and.l    %d0,%d3
    and.l    %d0,%d4
    
    or.l     %d3,(%a0)
    or.l     %d4,(%a1)
    
    lea      30(%a0),%a0
    lea      30(%a1),%a1
"
*/
/*
    |lightplane
    move.l   (%a0),%d3
    move.w   4(%a0),%d4
    not.l    %d3
    not.w    %d4
    or.l     6000(%a0),%d3
    or.w     6000+4(%a0),%d4
    move.w   %d4,-(%sp)
    move.l   %d3,-(%sp)
    
    |darkplane
    move.l   6000(%a0),%d3
    move.w   6000+4(%a0),%d4
    or.l     (%a0),%d3
    or.w     4(%a0),%d4
    move.w   %d4,-(%sp)
    move.l   %d3,-(%sp)
        
    | masque
    move.l   (%a1)+,%d3
    move.w   %d3,%d4
    lsr.l    %d0,%d3
    lsl.w    %d1,%d4
    or.l     %d5,%d3
    or.w     %d6,%d4
    and.l    %d3,(%a0)
    and.w    %d4,4(%a0)
    and.l    %d3,6000(%a0)
    and.w    %d4,6000+4(%a0)
    not.l    %d3
    not.w    %d4
    and.l    %d3,(%sp)
    and.l    %d3,4+2(%sp)
    and.w    %d4,4(%sp)
    and.w    %d4,4+2+4(%sp)
    
    | zone d'ombres
    move.l   (%sp)+,%d3
    move.w   (%sp)+,%d4
    or.l     %d3,6000(%a0)
    or.w     %d4,6000+4(%a0)
    move.l   (%sp)+,%d3
    move.w   (%sp)+,%d4
    or.l     %d3,(%a0)
    or.w     %d4,4(%a0)

| ??????
    move.l   (%a1)+,%d3
    move.l   (%a1)+,%d3 
*/
/*
    lea      30(%a0),%a0
    lea      30(%a1),%a1

"
    dbf      %d2,_loop_GraySprite8_SHADOW_R_1
"
    movem.l  (%sp)+,%d3-%d6/%a2
    addq.l   #2,%sp
    rts

    
| Two shiftings...

"
_loop_GraySprite8_SHADOW_R_2:
    lea      30(%a0),%a0
    lea      30(%a1),%a1

__loop_GraySprite8_SHADOW_R_2:
    move.w   (%a0),%d0
    move.w   (%a1),%d4
    
    move.w   %d0,%d3
    not.w    %d3
    or.w     %d4,%d3
    or.w     %d0,%d4

    moveq.l  #-1,%d0
    move.b   (%a2)+,%d0
    rol.w    %d1,%d0
    and.w    %d0,(%a0)
    and.w    %d0,(%a1)
    not.w    %d0
    and.w    %d0,%d3
    and.w    %d0,%d4*/
/*    
    moveq.l  #-1,%d0
    move.b   (%a2)+,%d0
    swap.w   %d0
    rol.l    %d1,%d0
    and.l    %d0,(%a0)
    and.l    %d0,(%a1)
    not.l    %d0
    swap.w   %d0
    and.l    %d0,%d3
    and.l    %d0,%d4
*/
    /*
    or.w     %d3,(%a0)
    or.w     %d4,(%a1)
"    

"
    dbf      %d2,__loop_GraySprite8_SHADOW_R_2
"
    movem.l  (%sp)+,%d3-%d6/%a2
    addq.l   #2,%sp
    rts
*/
